<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <title>全部费用申请(审批完成)</title>
    <link rel="stylesheet" th:href="@{/lib/layui/css/layui.css}" media="all">
    <link rel="stylesheet" th:href="@{/css/public.css}" media="all">
    <link rel="stylesheet" th:href="@{/lib/font-awesome-4.7.0/css/font-awesome.min.css}" media="all">
</head>
<body>
<div class="layuimini-container">
    <div class="layuimini-main">
        <fieldset class="table-search-fieldset">
            <legend>搜索信息(<b>收起-展开</b>)</legend>
            <div id="search-div" style="margin: 5px 10px -10px 0px">
                <form class="layui-form" action="" lay-filter="search-form">
                    <div class="layui-form-item" >
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">项目名称</label>
                            <div class="layui-input-inline" style="width: 200px">
                                <input type="text" id="xmmc" name="xmmc" autocomplete="off" class="layui-input">
                            </div>
                        </div>
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">ERP编号</label>
                            <div class="layui-input-inline" style="width: 225px">
                                <input type="text" id="erpbh" name="erpbh" autocomplete="off" class="layui-input">
                            </div>
                        </div>
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 90px">科研费号</label>
                            <div class="layui-input-inline" style="width: 150px">
                                <input type="text" id="bh" name="bh" autocomplete="off" class="layui-input">
                            </div>
                        </div>
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 30px">年份</label>
                            <div class="layui-input-inline" style="width: 150px">
                                <select name="nf" id="nf" lay-filter="status">
                                    <option value="0">全部</option>
                                    <option th:each="item:${yearList}" th:text="${item.nf}" th:value="${item.nf}"></option>
                                </select>
                            </div>
                        </div>

                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">审批状态</label>
                            <div class="layui-input-inline" style="width: 200px">
                                <select name="spzt" id="spzt" lay-filter="status">
                                    <option value="">全部</option>
                                    <option th:each="item:${approveList}" th:text="${item.name}" th:value="${item.name}"></option>
                                </select>
                            </div>
                        </div>
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">项目类型</label>
                            <div class="layui-input-inline" style="width: 200px">
                                <select name="xmlx" id="xmlx" lay-filter="status">
                                    <option value="">全部</option>
                                    <option th:each="item:${xmlxList}" th:text="${item.name}" th:value="${item.code}"></option>
                                </select>
                            </div>
                        </div>
<!--                        <div class="layui-inline">-->
<!--                            <label class="layui-form-label" style="width: 70px">是否备用金</label>-->
<!--                            <div class="layui-input-inline" style="width: 150px">-->
<!--                                <select name="sfbyj" id="sfbyj" lay-filter="status">-->
<!--                                    <option value="">全部</option>-->
<!--                                    <option value="1">是</option>-->
<!--                                    <option value="0">否</option>-->
<!--                                </select>-->
<!--                            </div>-->
<!--                        </div>-->
<!--                        <br>-->
                        <div class="layui-inline" style="left: -30px">
                            <label class="layui-form-label" style="width: 90px">电科院负责人</label>
                            <div class="layui-input-inline" style="width: 225px">
                                <input type="hidden" id="dkyfzr" name="dkyfzr" class="layui-input">
                                <input type="text" id="dkyfzrxm" name="dkyfzrxm" placeholder="可多选" class="layui-input" readonly>
                            </div>
                        </div>
                        <br>

                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px;">所属部门</label>
                            <div class="layui-input-inline" style="width: 200px;">
                                <input type="text" id="ssbmmc" name="ssbmmc" >
                            </div>
                        </div>
                        <div class="layui-inline">
                            <label class="layui-form-label" style="width: 60px">申请时间</label>
                            <div class="layui-input-inline" style="width: 100px">
                                <input type="text" name="sqsj1" id="sqsj1" placeholder="开始时间" class="layui-input" readonly>
                            </div>
                            <div class="layui-form-mid">-</div>
                            <div class="layui-input-inline" style="width: 100px">
                                <input type="text" name="sqsj2" id="sqsj2" placeholder="终止时间" class="layui-input" readonly>
                            </div>
                        </div>

                        <div class="layui-inline" style="margin-left: 0px">
                            <button type="submit" class="layui-btn" lay-submit lay-filter="data-search-btn"><i class="layui-icon"></i> 搜 索</button>
                            <button type="submit" class="layui-btn layui-btn-primary" lay-submit lay-filter="data-reset-btn"><i class="layui-icon layui-icon-refresh"></i> 重 置 </button>
                        </div>
                    </div>
                </form>
            </div>
        </fieldset>

        <script type="text/html" id="toolbarDemo">
            <div class="layui-btn-container">

                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="edit">
                    <i class="layui-icon layui-icon-edit" style="font-size: 10px;"></i>编辑
                </button>
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="view">
                    <i class="layui-icon layui-icon-file" style="font-size: 10px;"></i>查看
                </button>
                <button class="layui-btn layui-btn-sm layui-btn-danger" lay-event="delete">
                    <i class="layui-icon layui-icon-delete" style="font-size: 10px;"></i>删除
                </button>
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="spOption">
                    <i class="layui-icon layui-icon-edit" style="font-size: 10px;"></i>审核
                </button>
                <button class="layui-btn layui-btn-sm data-add-btn" lay-event="tjrevokeApprove">
                    <i class="layui-icon layui-icon-edit" style="font-size: 10px;"></i>撤销审批
                </button>
                <button class="layui-btn layui-btn-sm layui-btn-normal" lay-event="spList">
                    <i class="layui-icon layui-icon-list" style="font-size: 10px;"></i>审批列表
                </button>
                <button class="layui-btn layui-btn-sm layui-bg-black iconfont layui-icon-export" lay-event="export">
                    <i class="layui-icon" style="font-size: 10px;"></i>导出列表
                </button>
<!--                <button class="layui-btn layui-btn-sm" lay-event="exportExcel">-->
<!--                    <i class="layui-icon layui-icon-export" style="font-size: 10px;"></i>导出-->
<!--                </button>-->
            </div>
        </script>
        <input type="hidden" id="userId" name="userId" class="layui-input" th:value="${userId}">
        <table class="layui-hide" id="currentTableId" lay-filter="currentTableFilter"></table>
    </div>
</div>

<script>
    // 当文档加载完成后执行以下操作
    document.addEventListener('DOMContentLoaded', function() {
        // 获取下拉框元素
        var selectElement = document.getElementById('nf');
        // 获取当前年份并转换为字符串
        var currentYear = new Date().getFullYear().toString();

        // 遍历下拉框选项
        for (var i = 0; i < selectElement.options.length; i++) {
            // 如果选项的值与当前年份相匹配，则将该选项设为被选中状态并结束循环
            if (selectElement.options[i].value === currentYear) {
                selectElement.options[i].selected = true;
                break;
            }
        }
    });
</script>

<script>
    // 获取所有需要去除空格的输入框
    const inputs = [
        document.getElementById('xmmc'),
        document.getElementById('erpbh'),
        document.getElementById('bh')
    ];
    // 为每个输入框添加事件监听
    inputs.forEach(input => {
        input.addEventListener('input', function() {
            this.value = this.value.replace(/\s+/g, ''); // 去除空格
        });
    });
</script>
<script th:src="@{/lib/jquery-3.4.1/jquery-3.4.1.min.js}" charset="utf-8"></script>
<script th:src="@{/lib/layui/layui.js}" charset="utf-8"></script>
<script th:src="@{/lib/coco-message/coco-message.js}" charset="utf-8"></script>
<script th:src="@{/js/lay-config.js}" charset="utf-8"></script>
<script th:src="@{/lib/xm-select-v1.2.2/xm-select.js}" charset="utf-8"></script>
<script th:inline="javascript" type="text/javascript">
    AjaxUtil.ctx = /*[[@{/}]]*/'';
    var updateflag = 0;
    var fyApproval = {};

    layui.use(['form', 'table', 'tableSelect', 'laydate','layCascader'], function () {
        var form = layui.form,
            tableSelect = layui.tableSelect,
            laydate = layui.laydate,
            table = layui.table;
        layCascader = layui.layCascader;
        var userId = $("#userId").val();

        var sqsj1 = '',
            sqsj2 = '';

        var index2 = layer.load(0, {shade: 0.1});
        AjaxUtil.get({
            url: AjaxUtil.ctx + 'userinfo/listDeptForSelect',
            success: function (res) {
                layer.close(index2);

                var datalist = [];
                for (let item of res.data) {
                    item.value = item.deptName;
                    item.label = item.deptName;
                    datalist.push(item);
                }
                console.log(datalist)
                // 扁平数据转树
                var options = arrayToTree(datalist, "50");

                // 初始化cascader实例
                var cascader = layCascader({
                    elem: '#ssbmmc',
                    clearable: true,
                    showAllLevels: false, // 配置仅显示最后一级
                    props: {
                        checkStrictly: true, // 配置选择任意一级选项
                    },
                    options: options
                });

                // 监听cascader变化
                cascader.changeEvent(function (value, node) {
                    // 主动关闭面板
                    cascader.close();
                    $("#deptId").val(value);
                    console.log(node);
                });
            },
            error: function (error) {
                layer.close(index2);
                Message.error('获取部门信息失败！', 1000);
            }
        });


        //申请时间
        laydate.render({
            elem: '#sqsj1',
            done: function (value, date, endDate) {
                sqsj1 = $("#sqsj1").val();
                sqsj2 = $("#sqsj2").val();
                if (sqsj1 != "" && sqsj2 != "") {
                    if (sqsj1 > sqsj2) {
                        Message.warning("起始时间不能晚于终止时间！", 1500);
                        $("#sqsj1").val("");
                    }
                }
            }
        });
        laydate.render({
            elem: '#sqsj2',
            done: function (value, date, endDate) {
                sqsj1 = $("#sqsj1").val();
                sqsj2 = $("#sqsj2").val();
                if (sqsj1 != "" && sqsj2 != "") {
                    if (sqsj1 > sqsj2) {
                        Message.warning("终止时间不能早于开始时间！", 1500);
                        $("#sqsj2").val("");
                    }
                }
            }
        });

        //电科院负责人
        tableSelect.render({
            elem: '#dkyfzrxm',
            checkedKey: 'id',
            searchKey: 'xm',
            searchPlaceholder: '搜索姓名',
            table: {
                url: AjaxUtil.ctx + 'basePerson/rylist',
                cols: [
                    [
                        {type: "checkbox", fixed: 'left'},
                        {type: 'numbers', align: 'center',title: '序号'},
                        {field: 'xm', width: '15%', title: '姓名', align: 'left'},
                        {field: 'dwmc', title: '公司/单位', align: 'left',width: '30%'},
                        {field: 'bmmc', title: '部门', align:'left',width: '30%' }
                    ]
                ]
            },
            done: function (elem, data) {
                var NEWJSON = [];
                var NEWJSON1 = [];
                layui.each(data.data, function (index, item) {
                    NEWJSON.push(item.xm);
                    NEWJSON1.push(item.id);
                })
                elem.val(NEWJSON.join(","));
                $("#dkyfzr").val(NEWJSON1.join(","));
            }
        });
        var year = document.getElementById('nf').value;

        var currTable = table.render({
            elem: '#currentTableId',
            url: AjaxUtil.ctx + 'staBudgetapproval/list_approving/?nf='+year,
            method: 'post',
            toolbar: '#toolbarDemo',
            // defaultToolbar: ['filter', 'print'],
            cols: [
                [
                    {type: "checkbox", fixed: 'left'},
                    {type: 'numbers', align: 'center', fixed: 'left'},
                    {field: 'xmmc', width: '20%', title: '项目名称',fixed: "left"},
                    {field: 'spzt', width: '9%', title: '审批状态', sort: true},
                    {field: 'bh', width: '8%', title: '科研费号'},

                    // {field: 'sqmc', width: '25%', title: '申请名称'},
                    {field: 'erpbh', width: '9%', title: 'ERP编号'},
                    {field: 'xmlxmc', width: '10%', title: '项目类型'},
                    {field: 'fylbmc', width: '7%', title: '费用类别'},
                    {field: 'sqje', width: '7%', title: '申请金额(元)'},
                    {field: 'sqrxm', width: '5%', title: '申请人'},
                    {field: 'dkyfzrxm', width: '8%', title: '电科院负责人'},
                    {field: 'ssbmmc', width: '8%', title: '所属部门'},
                    {field: 'nf', width: '5%', title: '年份'},
                    {field: 'sqsj', width: '8%', title: '申请时间', align: 'center'}
                ]
            ],
            autoSort: false,
            limits: [10, 15, 20, 25, 50, 100],
            limit: 10,
            page: true,
            skin: 'grid',
            parseData: function (res) { //res 即为原始返回的数据
                return {
                    "code": res.code, //解析接口状态
                    "msg": res.message, //解析提示文本
                    "count": res.data.total, //解析数据长度
                    "data": res.data.rows //解析数据列表
                };
            },
            done: function (res, curr, count) { // done为数据渲染完的回调
                // 测试打印出后端返回的权限列表
                // let permissionSet = [[${permissionSet}]];
                // console.log(JSON.stringify(permissionSet));
            }
        });

        // 监听搜索操作
        form.on('submit(data-search-btn)', function (data) {
            // 执行搜索重载
            currTable.reload({
                page: {
                    curr: 1 // 页码从1开始
                },
                where: form.val("search-form")
            });
            return false;
        });

        // 监听重置操作
        form.on('submit(data-reset-btn)', function (data) {
            form.val("search-form", {
                "bh": '',
                "erpbh": '',
                "xmlx": '',
                "sfbyj": '',
                "xmmc": '',
                "ssbmmc": '',
                "nf": '0',
                "spzt": '',
                "sfbz": '',
                "dkyfzr": '',
                "dkyfzrxm":'',
                "sqsj1":'',
                "sqsj2":''

            });
            // 执行搜索重载
            currTable.reload({
                page: {
                    curr: 1
                },
                where: form.val("search-form")
            });
            return false;
        });


        // 监听工具栏事件
        table.on('toolbar(currentTableFilter)', function (obj) {
            if (obj.event === 'add') {  // 监听添加操作
                layer.open({
                    title: '新建费用申请',
                    type: 2,
                    shade: 0.3,
                    maxmin: true,
                    area: ['1020px', layerheight + 'px'],
                    content: AjaxUtil.ctx + 'staBudgetapproval/forApplyAdd',
                    end: function (index) {
                        // 重载表格
                        if(updateflag == 1)
                            currTable.reload();
                        updateflag =0;
                    }
                });
            }
            else if (obj.event == 'edit') {
                var dataApproval = table.cache["currentTableId"];
                if(dataApproval.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要编辑的费用申请！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行编辑！", 1500);
                } else if (data[0].spzt == "作废") {
                    Message.warning("该费用申请已作废！", 1500);
                } else if (data[0].spzt == "审批结束") {
                    Message.warning("该费用申请已审批结束，不能修改！", 1500);
                } else if (data[0].spzt != null && data[0].spzt.indexOf("未提交") < 0) {
                    Message.warning("该费用申请审批中，不能修改！", 1500);
                } else {
                    layer.open({
                        title: '编辑费用申请',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1020px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'staBudgetapproval/forApplyUpdate/' + data[0].id,
                        end: function (index) {
                            if(updateflag == 1)
                                currTable.reload();
                            updateflag =0;
                        }
                    });
                    // layer.full(index);
                }
            }
            else if (obj.event == 'view') {
                var dataApproval = table.cache["currentTableId"];
                if(dataApproval.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要查看的费用申请！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行查看！", 1500);
                } else {
                    layer.open({
                        title: '浏览费用申请',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1020px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'staBudgetapproval/forApplyView/' + data[0].id,
                        end: function (index) {
                            layer.close(index);
                        }
                    });
                    // layer.full(index);
                }
            }
            else if (obj.event === 'delete') {  // 监听删除操作
                var dataApproval = table.cache["currentTableId"];
                if(dataApproval.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    ,data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要删除的费用申请！", 1500);
                    return;
                } else {
                    for(let item of data) {
                        if(item.spzt != "未提交") {
                            if(item.spzt == "审批结束")
                                Message.warning("存在已审批结束的费用申请，不能直接删除！", 2000);
                            else if (data[0].spzt != null)
                                Message.warning("存在审批中的费用申请，不能直接删除！", 2000);
                            return;
                        }
                    }
                }
                layer.confirm('确定批量删除费用申请吗？', function (index) {
                    layer.close(index);
                    AjaxUtil.post({
                        url: AjaxUtil.ctx + "staBudgetapproval/batchDelete",
                        contentType: "application/json",
                        data: JSON.stringify(data),
                        success: function (res) {
                            if (res.code === 0) {
                                Message.success(1500, res.message, function () {
                                    // 重载表格
                                    currTable.reload();
                                });
                            } else {
                                Message.error(res.message, 1000);
                            }
                        },
                        error: function (error) {
                        }
                    });
                });
            }
            else if (obj.event === 'tjApprove') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要提交审批的费用申请！", 2000);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行提交！", 1500);
                } else if (data[0].spzt == "审批结束") {
                    Message.warning("该费用申请已审批结束！", 1500);
                } else if (data[0].spzt == "作废") {
                    Message.warning("该费用申请已作废！", 1500);
                } else if (data[0].spzt != null && data[0].spzt.indexOf("未提交") < 0) {
                    Message.warning("该费用申请正在审批中……", 1500);
                } else {
                    xmApproval = {
                        "xmid": data[0].id,
                        "xm": data[0].sqmc,
                        "zt": data[0].spzt,
                        "sqje": data[0].sqje
                    };
                    if(data[0].spzt == null) {
                        xmApproval.zt = "未提交";
                        data[0].spzt = "未提交";
                    }

                    var content = AjaxUtil.ctx + 'staBudgetapproval/forApproveAdd';
                    if (data[0].spzt != "未提交")
                        content = AjaxUtil.ctx + 'staBudgetapproval/forApproveUpdate/' + data[0].id + '/' + data[0].sqje + '?spzt=' + data[0].spzt;

                    var index = layer.open({
                        title: '提交审批',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1025px', layerheight + 'px'],
                        content: content,
                        end: function () {
                            if (updateflag == 1)
                                currTable.reload();
                            updateflag = 0;
                            layer.close(index);
                        }
                    });
                }
            }
            else if (obj.event === 'spOption') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要审批的费用申请！", 2000);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行审批！", 1500);
                } else if (data[0].spzt == null || data[0].spzt.indexOf("未提交") >= 0) {
                    Message.warning("该费用申请尚未提交审批！", 1500);
                } else if (data[0].spzt == "审批结束") {
                    Message.warning("该费用申请已审批结束！", 2000);
                } else if (data[0].spzt == "作废") {
                    Message.warning("该费用申请已作废！", 1500);
                } else {
                    xmApproval = {
                        "xmid": data[0].id,
                        "xm": data[0].sqmc,
                        "zt": data[0].spzt,
                        "sqje": data[0].sqje
                    };

                    var content = AjaxUtil.ctx + 'staBudgetapproval/forApproveAdd';
                    if (data[0].spzt != "未提交")
                        content = AjaxUtil.ctx + 'staBudgetapproval/forApproveUpdate/' + data[0].id + '/' + data[0].sqje + '?spzt=' + data[0].spzt;

                    layer.open({
                        title: '审批意见',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1025px', layerheight + 'px'],
                        content: content,
                        end: function (index) {
                            if (updateflag == 1)
                                currTable.reload();
                            updateflag = 0;
                        }
                    });
                }
            }
            else if (obj.event === 'spList') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要查看审批列表的费用申请！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行查看！", 1500);
                } else if (data[0].spzt == null || data[0].spzt == "未提交") {
                    Message.warning("该备费用申请尚未提交审批！", 1500);
                } else {
                    xmApproval = {
                        "xmid": data[0].id,
                        "xm": data[0].sqmc,
                        "zt": data[0].spzt,
                        "sqje": data[0].sqje
                    };

                    var index = layer.open({
                        title: '审批列表',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['1300px', layerheight + 'px'],
                        content: AjaxUtil.ctx + 'staBudgetapproval/forApproveList',
                        end: function () {
                            layer.close(index);
                        }
                    });
                }
            }
            else if (obj.event === 'reimburse') {
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0) {
                    Message.warning("请选择要报账的费用申请！", 1500);
                } else if (data.length > 1) {
                    Message.warning("请选择一条记录进行报账！", 1500);
                } else if (data[0].spzt == "作废") {
                    Message.warning("该费用申请已作废！", 1500);
                } else if (data[0].spzt.indexOf("未提交") >= 0) {
                    Message.warning("该费用申请尚未提交审批！", 1500);
                } else if (data[0].spzt != "审批结束") {
                    Message.warning("该费用申请正在审批中……", 1500);
                } else if (data[0].sfbz == 1) {
                    Message.warning("该费用申请已报账", 1500);
                } else {
                    var index = layer.open({
                        title: '新建报账',
                        type: 2,
                        shade: 0.3,
                        maxmin: true,
                        shadeClose: true,
                        area: ['970px', '750px'],
                        content: AjaxUtil.ctx + "staReimbursement/forAdd/" +data[0].id,
                        end: function () {
                            if (updateflag == 1)
                                currTable.reload();
                            updateflag = 0;
                            layer.close(index);
                        }
                    });
                }
            } else if (obj.event === 'nullify') {  // 监听作废操作
                var projects = table.cache["currentTableId"];
                if (projects.length == 0)
                    return;

                var checkStatus = table.checkStatus('currentTableId')
                    , data = checkStatus.data;
                if (data == null || data.length === 0)
                    Message.warning("请选择要作废的费用申请！", 1000);
                else {
                    layer.confirm('确定批量作废费用申请吗？', function (index) {
                        layer.close(index);
                        AjaxUtil.post({
                            url: AjaxUtil.ctx + "staBudgetapproval/batchNullify",
                            contentType: "application/json",
                            data: JSON.stringify(data),
                            success: function (res) {
                                if (res.code === 0) {
                                    Message.success(1500, res.message, function () {
                                        // 重载表格
                                        currTable.reload();
                                    });
                                } else {
                                    Message.error(res.message, 1000);
                                }
                            },
                            error: function (error) {
                            }
                        });
                    });
                }
            }

    else if(obj.event==='tjrevokeApprove'){
            var projects = table.cache["currentTableId"];
            if (projects.length == 0)
                return;
            var checkStatus = table.checkStatus('currentTableId')
                , data = checkStatus.data;
            if (data == null || data.length === 0) {
                Message.warning("请选择要撤销的任务书！", 1500);
            } else if (data.length > 1) {
                Message.warning("请选择一条记录进行撤销！", 1500);
            } else if (data[0].spzt == "审批结束") {
                Message.warning("该任务书已审批结束！", 1500);
            } else if (data[0].cjr != userId) {
                Message.error("您不是该任务书的创建人！", 1500);
            } else {
                xmApproval = {
                    "xmid": data[0].id,
                    "xm": data[0].zwmc,
                    "zt": "未提交"
                };
                if(data[0].spzt == null) {
                    xmApproval.zt = "未提交";
                    data[0].spzt = "未提交";
                }
                var project = {
                    "id": xmApproval.xmid,
                    "spzt": '未提交'
                }
                layer.confirm('确定撤销项目任务书吗？', function (index) {
                    layer.close(index);
                    AjaxUtil.post({
                        url: AjaxUtil.ctx + "prjProject/TJrevokeApprove",
                        contentType: "application/json",
                        data: JSON.stringify(project),
                        success: function (res) {
                            if (res.code === 0) {
                                Message.success(1500, res.message, function () {
                                    // 重载表格
                                    currTable.reload();
                                });
                            } else {
                                Message.error(res.message, 1000);
                            }
                        },
                        error: function (error) {
                        }
                    });
                });
            }
        }else if (obj.event === 'export'){
                var formData = form.val('search-form');
                // 获取form 表单代码
                console.log(formData);
                var formDataString = JSON.stringify(formData);
                AjaxUtil.post({
                    url:AjaxUtil.ctx +'staBudgetapproval/getAlls/'+formDataString,
                    contentType: "application/json",
                    timeout: 15000, //大批量导出时会出现超时问题
                    success: function(res){
                        console.log(res);
                        table.exportFile('currentTableId',res.data,'xlsx');
                    },
                    error:function (error) {
                        Message.error(error,2000)

                    }
                });

            }
    });

        //双击
        table.on('rowDouble(currentTableFilter)', function (obj) {
            var data = obj.data;
            layer.open({
                title: '浏览费用申请',
                type: 2,
                shade: 0.3,
                maxmin: true,
                shadeClose: true,
                area: ['1020px', layerheight + 'px'],
                content: AjaxUtil.ctx + 'staBudgetapproval/forApplyView/' + data.id,
                end: function (index) {
                    layer.close(index);
                }
            });
        });
    });
    // 监听表格选框事件
    // table.on

    function setUpdateFlag() {
        updateflag = 1;
    }
    function getXmApproval() {
        return xmApproval;
    }
    function arrayToTree(data, firstPid) {
        const result = [];
        getChildren(data, result, firstPid)
        return result;
    }
    function getChildren(data, result, parentId) {
        for (const item of data) {
            if (item.parentId === parentId) {
                const newItem = {...item, children: []};
                result.push(newItem);
                getChildren(data, newItem.children, item.deptId);
            }
        }
    }
</script>
</body>
</html>